/*
 * enter.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
#ifndef _NO_DEPEND
#   include "ntserv_protos.h"
#endif

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

extern int                    fclose P_((FILE *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern int                    fflush P_((FILE *));
extern int                    shmget P_((key_t, int, int));
extern void                   perror P_((const char *));
extern void *                 shmat P_((int, void *, int));

#undef P_
#endif

/* Enter the game */

long            random();

void
enter(tno, disp, pno, s_type)
   int             tno;
   char           *disp;
   int             pno;
   int             s_type;
{
   static int      lastteam = -1;
   static int      lastrank = -1;
   char            buf[80];
   char            addrbuf[10];
   int             startplanet;
#if defined(CYBORGS) || defined(BASEPRACTICE)	/* preserve cyborg flag */
   unsigned int	   oldflags = me->p_flags;
#endif

   (void) strncpy(me->p_name, pseudo, sizeof(me->p_name));
   me->p_name[sizeof(me->p_name) - 1] = '\0';
   getship(myship, s_type);
   /* Need 2 kills to use plasma torpedoes */
   if ((s_type != STARBASE) && (s_type != ATT) && plkills > 0) {
      me->p_ship.s_plasmacost = -1;
   }
   me->p_updates = 0;

   me->p_flags = PFSHIELD;

#ifdef CYBORGS			/* preserve cyborg flag */
   if ((oldflags & PFCYBORG) 
#ifdef BASEPRACTICE
   && !(oldflags & PFBPROBOT)
#endif
   ) {
      /*
       * a special symbol added to the name (first used at
       * bezier.berkeley.edu by Scott Drellishak
       */

      int             x = strlen(me->p_name);
      if (me->p_name[x - 1] != '*') {
	 if (x > 13)
	    x = 13;
	 me->p_name[x] = ' ';
	 me->p_name[x + 1] = '*';
	 me->p_name[x + 2] = '\0';
      }
      me->p_flags |= PFCYBORG;
   }
#endif

#ifdef BASEPRACTICE
   if(oldflags & PFBPROBOT){
      int             x = strlen(me->p_name);
      if (me->p_name[x - 1] != 01) {
	 if (x > 13)
	    x = 13;
	 me->p_name[x] = ' ';
	 me->p_name[x + 1] = 01;
	 me->p_name[x + 2] = '\0';
      }
      me->p_flags |= PFBPROBOT;
   }
#endif

   if (s_type == STARBASE)
      me->p_flags |= PFDOCKOK;
   me->p_dir = 0;
   me->p_desdir = 0;
   me->p_speed = 0;
   me->p_desspeed = 0;
   me->p_subspeed = 0;
   me->p_team = (1 << tno);
   /* should handle independents correctly */
   if (tno > 3) {
      me->p_team = 0;
      me->p_x = GWIDTH / 2;
      me->p_y = GWIDTH / 2;
   } else {
      for (;;) {
	 startplanet = tno * 10 + random() % 10;
	 if (startplanets[startplanet])
	    break;
      }
      me->p_x = planets[startplanet].pl_x + (random() % 10000) - 5000;
      me->p_y = planets[startplanet].pl_y + (random() % 10000) - 5000;
      if (me->p_x < 0)
	 me->p_x = 0;
      if (me->p_y < 0)
	 me->p_y = 0;
      if (me->p_x > GWIDTH)
	 me->p_x = GWIDTH;
      if (me->p_y > GWIDTH)
	 me->p_y = GWIDTH;
   }
   me->p_ntorp = 0;
   me->p_cloakphase = 0;
   me->p_nplasmatorp = 0;
   me->p_damage = 0;
   me->p_subdamage = 0;
   me->p_etemp = 0;
   me->p_etime = 0;
   me->p_wtemp = 0;
   me->p_wtime = 0;
   me->p_shield = me->p_ship.s_maxshield;
   me->p_subshield = 0;
   me->p_swar = 0;
/*
   if (!keeppeace)
      me->p_hostile = (FED | ROM | KLI | ORI);
*/
   if (!keeppeace) auto_peace();
   me->p_hostile &= ~me->p_team;
   me->p_kills = 0.0;
   me->p_armies = 0;
   me->p_docked = 0;
   me->p_port[0] = VACANT;
   me->p_port[1] = VACANT;
   me->p_port[2] = VACANT;
   me->p_port[3] = VACANT;
#ifdef SB_DOCK
   me->p_numdocked = 0;
   me->p_portdocked = VACANT;
#endif

   if (allwar) {
      me->p_hostile = (FED | ROM | KLI | ORI);
      me->p_swar = (FED | ROM | KLI | ORI);
   }

   sprintf(buf, "%c%c", teamlet[me->p_team], shipnos[me->p_no]);
   strncpy(me->p_mapchars, buf, 2);
   if (lastteam != tno || lastrank != mystats->st_rank) {
      char            buf[256];
      lastteam = tno;
      lastrank = mystats->st_rank;
#ifdef LONGHOST
        /* new-style join message 4/13/92 TC */
        sprintf(buf, "%s %.16s is now %2.2s (%.16s@%.32s)",
                ranks[me->p_stats.st_rank].name,
                me->p_name,
                me->p_mapchars,
                me->p_login,
                me->p_monitor);
#else
      sprintf(buf, "%s %.16s joining as %2.2s (%.16s@%.16s)",
	      ranks[me->p_stats.st_rank].name,
	      me->p_name,
	      me->p_mapchars,
	      me->p_login,
	      me->p_monitor);
#endif
      sprintf(addrbuf, " %c%c->ALL",
	      teamlet[me->p_team], shipnos[me->p_no]);
      pmessage2(buf, 0, MALL|MJOIN, addrbuf, me->p_no);

      if (announceTop10 == 1) {
	 FILE           *top10File;
	 int             foundIt = 0;
	 char            myBuf[200];

	 if ((top10File = fopen(TOP10FILENAME, "r")) != NULL) {
	    while (fgets(myBuf, 33, top10File) != NULL) {
	       if (strlen(myBuf) == 0)
		  break;
	       myBuf[strlen(myBuf) - 1] = '\0';	/* Get rid of the newline */
	       if (strcmp(myBuf, me->p_name) == 0) {
		  foundIt = 1;
		  break;
	       }
	    }
	    fclose(top10File);
	    if (foundIt != 0) {
	       sprintf(buf, "%s %.16s is one of the top ranked players on this server.",
		       ranks[me->p_stats.st_rank].name, me->p_name);
	       pmessage2(buf, 0, MALL, "GOD->ALL", me->p_no);
	    }
	 } else {		/* we couldn't open the top 10 file */
	    fprintf(stderr, "Couldn't open the top 10 file.\n");
	    fflush(stderr);
	 }
      }
   }
   me->p_fuel = myship->s_maxfuel;
   delay = 0;
}

void
openmem()
{
   extern int      errno;
   int             shmemKey = PKEY;
   int             shmid;
   struct memory  *sharedMemory;
   int             i;

   errno = 0;
   shmid = shmget(shmemKey, 0, 0);
   if (shmid < 0) {
      if (errno != ENOENT) {
	 perror("shmget");
	 exit(1);
      }
      /* TSH: make this guy try a little harder */
      for (i = 0; i < 10; i++) {
	 startdaemon();
	 my_sleep(2);
	 shmid = shmget(shmemKey, 0, 0);
	 if (shmid != -1)
	    break;
      }
      if (shmid < 0) {
	 fprintf(stderr, "ntserv: Can't start daemon.\n");
	 fflush(stderr);
	 exit(1);
      }
   }
   sharedMemory = (struct memory *) shmat(shmid, 0, 0);
   if (sharedMemory == (struct memory *) - 1) {
      perror("shared memory");
      exit(1);
   }
   players = sharedMemory->players;
   torps = sharedMemory->torps;
   plasmatorps = sharedMemory->plasmatorps;
   status = sharedMemory->status;
   planets = sharedMemory->planets;
   phasers = sharedMemory->phasers;
   mctl = sharedMemory->mctl;
   messages = sharedMemory->messages;
   teams = sharedMemory->teams;
#ifdef VOTE
   vote = &sharedMemory->vote;
#endif
}

/* my idea of avoiding using the war window 8/16/91 TC */
void
auto_peace()
{
   int i, num[MAXTEAM+1];      /* corrected 6/22/92 TC */
   struct player       *p;

   num[0] = num[FED] = num[ROM] = num[KLI] = num[ORI] = 0;
   for (i = 0, p = players; i < MAXPLAYER; i++, p++)
      if (p->p_status != PFREE)
	 num[p->p_team]++;
   if (status->tourn)
      me->p_hostile =
	 ((FED * (num[FED] >= tournplayers)) |
	 (ROM * (num[ROM] >= tournplayers)) |
	 (KLI * (num[KLI] >= tournplayers)) |
	 (ORI * (num[ORI] >= tournplayers)));
   else
      me->p_hostile = FED|ROM|KLI|ORI;
}

