#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "defs.h"


#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

#ifdef USE_SYS_PROTOS
extern int                    shmget P_((key_t, int, int));
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern int                    fflush P_((FILE *));
extern int                    scanf P_((const char *, ...));
extern int                    shmctl P_((int, int, ...));
#endif

#undef P_

void
main()
{
    extern int errno;
    int shmemKey = PKEY;
    int shmid;
    char	answer[80];

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
        if (errno != ENOENT) {
            perror("shmget");
            exit(1);
        }
        shmid = shmget(shmemKey, 0, 0);
        if (shmid < 0) {
            fprintf(stderr, "nuke: Daemon not running\n");
            exit (1);
        }
    }
    fprintf(stderr, "Confirm removal of shared memory segment (yes/no): ");
    fflush(stderr);
    scanf("%s", answer);

    if(strcmp(answer, "yes")!=0){
      fprintf(stderr, "aborting.\n");
      exit(0);
    }

    shmctl(shmid, IPC_RMID, 0);		/* nuke it */
}
