#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include <time.h>
#include "defs.h"
#include "struct.h"

#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

/* watchmes.c */
void openmem P_((void));
void log P_((struct message *m));
int instr P_((char *string1, char *string2));

#ifdef USE_SYS_PROTOS
extern int                    shmget P_((key_t, int, int));
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern void *                 shmat P_((int, void *, int));
extern int                    printf P_((const char *, ...));
extern int                    fflush P_((FILE *));
extern unsigned int           sleep P_((unsigned int));
extern time_t                 time P_((time_t *));
#endif

#undef P_

struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

void
openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    fprintf(stderr, "shmget\n");
	    exit(1);
	}
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "watchmes: Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	fprintf(stderr, "shared memory\n");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}

void
main(argc, argv)
int argc;
char *argv[];
{
   register	i = atoi(argv[1]);
   int		olddir = 0, z=0;

   openmem();
   while (1){
      if(olddir != players[i].p_desdir){

	 printf("= %d\n", angdist(olddir, players[i].p_desdir));
	 olddir = players[i].p_desdir;
      }
      z++;
   }
}


int
angdist(x, y)
   unsigned char   x, y;
{
   register unsigned char res;

   res = ABS(x - y);
   if (res > 128)
      return (256 - (int) res);
   return ((int) res);
}

